// LibSymbolInfo.h: interface for the CLibSymbolInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIBSYMBOLINFO_H__1A7003B4_BA53_11D1_AE46_1CFB51000000__INCLUDED_)
#define AFX_LIBSYMBOLINFO_H__1A7003B4_BA53_11D1_AE46_1CFB51000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CLibSymbolInfo  
{
public:
	CLibSymbolInfo();
	virtual ~CLibSymbolInfo();
	BOOL DumpSymbols(LPTSTR lpszLibPathName, CStdioFile* pFile);
	BOOL GrepSymbols(LPTSTR lpszLibPathName, CWnd* pWnd, const CString& sSymbolToGrep,
		const BOOL& bMatchCase, const BOOL& bMatchWholeWord);
	CString GetLastError() const;
	int GetOccurences() const;

protected:
	CString m_strResultsString;
	CString m_strErrorMsg;
	BOOL m_bGrep;
	BOOL m_bDump;
	BOOL m_bMatchCase;
	BOOL m_bMatchWholeWord;
	long m_nOccurences;

	void UpdateOutputWindow(const CString& sBuff, CWnd* pWnd);
	BOOL DumpOrGrep(LPTSTR lpszLibPathName, CStdioFile* pFile, CWnd* pWnd,
		LPCTSTR lpszsSymbolToGrep); 
	BOOL IsRegularLibSymbol( PSTR pszSymbolName );
	DWORD ConvertBigEndian(DWORD bigEndian);
	void DisplayLibInfoForSymbol( PSTR pszSymbol, PVOID pFileBase, DWORD archiveMemberOffset,
		CStdioFile* pFile, CWnd* pWnd, LPCTSTR lpszSymbolToGrep, LPTSTR lpszLibPathName);
};

#endif // !defined(AFX_LIBSYMBOLINFO_H__1A7003B4_BA53_11D1_AE46_1CFB51000000__INCLUDED_)